Package org.springframework.beans.factory.support

# Class StaticListableBeanFactory

java.lang.Object
org.springframework.beans.factory.support.StaticListableBeanFactory

All Implemented Interfaces:
  `BeanFactory`, `ListableBeanFactory`

public class StaticListableBeanFactory extends Object implements ListableBeanFactory
Static `BeanFactory` implementation which allows one to register existing singleton instances programmatically.

Does not have support for prototype beans or aliases.

Serves as an example for a simple implementation of the `ListableBeanFactory` interface, managing existing bean instances rather than creating new ones based on bean definitions, and not implementing any extended SPI interfaces (such as `ConfigurableBeanFactory`).

For a full-fledged factory based on bean definitions, have a look at `DefaultListableBeanFactory`.

Since:
  06.01.2003
Author:
  Rod Johnson, Juergen Hoeller, Sam Brannen
See Also:
  - `DefaultListableBeanFactory`

## Field Summary

### Fields inherited from interface org.springframework.beans.factory.BeanFactory

`FACTORY_BEAN_PREFIX, FACTORY_BEAN_PREFIX_CHAR`

## Constructor Summary

Constructors
Constructor
Description
`StaticListableBeanFactory()`
Create a regular `StaticListableBeanFactory`, to be populated with singleton bean instances through `addBean(java.lang.String, java.lang.Object)` calls.
`StaticListableBeanFactory(Map<String,Object> beans)`
Create a `StaticListableBeanFactory` wrapping the given `Map`.

## Method Summary

Modifier and Type
Method
Description
`void`
`addBean(String name, Object bean)`
Add a new singleton bean.
`boolean`
`containsBean(String name)`
Does this bean factory contain a bean definition or externally registered singleton instance with the given name?
`boolean`
`containsBeanDefinition(String name)`
Check if this bean factory contains a bean definition with the given name.
`<A extends Annotation>
Set<A>`
`findAllAnnotationsOnBean(String beanName, Class<A> annotationType, boolean allowFactoryBeanInit)`
Find all `Annotation` instances of `annotationType` on the specified bean, traversing its interfaces and superclasses if no annotation can be found on the given class itself, as well as checking the bean's factory method (if any).
`<A extends Annotation>
A`
`findAnnotationOnBean(String beanName, Class<A> annotationType)`
Find an `Annotation` of `annotationType` on the specified bean, traversing its interfaces and superclasses if no annotation can be found on the given class itself, as well as checking the bean's factory method (if any).
`<A extends Annotation>
A`
`findAnnotationOnBean(String beanName, Class<A> annotationType, boolean allowFactoryBeanInit)`
Find an `Annotation` of `annotationType` on the specified bean, traversing its interfaces and superclasses if no annotation can be found on the given class itself, as well as checking the bean's factory method (if any).
`String[]`
`getAliases(String name)`
Return the aliases for the given bean name, if any.
`<T> T`
`getBean(Class<T> requiredType)`
Return the bean instance that uniquely matches the given object type, if any.
`<T> T`
`getBean(Class<T> requiredType, Object... args)`
Return an instance, which may be shared or independent, of the specified bean.
`Object`
`getBean(String name)`
Return an instance, which may be shared or independent, of the specified bean.
`<T> T`
`getBean(String name, Class<T> requiredType)`
Return an instance, which may be shared or independent, of the specified bean.
`Object`
`getBean(String name, Object... args)`
Return an instance, which may be shared or independent, of the specified bean.
`int`
`getBeanDefinitionCount()`
Return the number of beans defined in the factory.
`String[]`
`getBeanDefinitionNames()`
Return the names of all beans defined in this factory.
`String[]`
`getBeanNamesForAnnotation(Class<? extends Annotation> annotationType)`
Find all names of beans which are annotated with the supplied `Annotation` type, without creating corresponding bean instances yet.
`String[]`
`getBeanNamesForType(Class<?> type)`
Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`String[]`
`getBeanNamesForType(Class<?> type, boolean includeNonSingletons, boolean allowEagerInit)`
Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`String[]`
`getBeanNamesForType(org.springframework.core.ResolvableType type)`
Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`String[]`
`getBeanNamesForType(org.springframework.core.ResolvableType type, boolean includeNonSingletons, boolean allowEagerInit)`
Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`<T> ObjectProvider<T>`
`getBeanProvider(Class<T> requiredType)`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.
`<T> ObjectProvider<T>`
`getBeanProvider(Class<T> requiredType, boolean allowEagerInit)`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.
`<T> ObjectProvider<T>`
`getBeanProvider(org.springframework.core.ResolvableType requiredType)`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.
`<T> ObjectProvider<T>`
`getBeanProvider(org.springframework.core.ResolvableType requiredType, boolean allowEagerInit)`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.
`<T> Map<String,T>`
`getBeansOfType(Class<T> type)`
Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`<T> Map<String,T>`
`getBeansOfType(Class<T> type, boolean includeNonSingletons, boolean allowEagerInit)`
Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`Map<String,Object>`
`getBeansWithAnnotation(Class<? extends Annotation> annotationType)`
Find all beans which are annotated with the supplied `Annotation` type, returning a Map of bean names with corresponding bean instances.
`Class<?>`
`getType(String name)`
Determine the type of the bean with the given name.
`Class<?>`
`getType(String name, boolean allowFactoryBeanInit)`
Determine the type of the bean with the given name.
`boolean`
`isPrototype(String name)`
Is this bean a prototype? That is, will `BeanFactory.getBean(java.lang.String)` always return independent instances?
`boolean`
`isSingleton(String name)`
Is this bean a shared singleton? That is, will `BeanFactory.getBean(java.lang.String)` always return the same instance?
`boolean`
`isTypeMatch(String name, Class<?> typeToMatch)`
Check whether the bean with the given name matches the specified type.
`boolean`
`isTypeMatch(String name, org.springframework.core.ResolvableType typeToMatch)`
Check whether the bean with the given name matches the specified type.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### StaticListableBeanFactory

public StaticListableBeanFactory()
Create a regular `StaticListableBeanFactory`, to be populated with singleton bean instances through `addBean(java.lang.String, java.lang.Object)` calls.

### StaticListableBeanFactory

public StaticListableBeanFactory(Map<String,Object> beans)
Create a `StaticListableBeanFactory` wrapping the given `Map`.

Note that the given `Map` may be pre-populated with beans; or new, still allowing for beans to be registered via `addBean(java.lang.String, java.lang.Object)`; or `Collections.emptyMap()` for a dummy factory which enforces operating against an empty set of beans.

Parameters:
  `beans` - a `Map` for holding this factory's beans, with the bean name as key and the corresponding singleton object as value
Since:
  4.3

## Method Details

### addBean

public void addBean(String name, Object bean)
Add a new singleton bean.

Will overwrite any existing instance for the given name.

Parameters:
  `name` - the name of the bean
  `bean` - the bean instance

### getBean

public Object getBean(String name) throws BeansException
Description copied from interface: `BeanFactory`
Return an instance, which may be shared or independent, of the specified bean.

This method allows a Spring BeanFactory to be used as a replacement for the Singleton or Prototype design pattern. Callers may retain references to returned objects in the case of Singleton beans.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `getBean` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to retrieve
Returns:
  an instance of the bean. Note that the return value will never be `null` but possibly a stub for `null` returned from a factory method, to be checked via `equals(null)`. Consider using `BeanFactory.getBeanProvider(Class)` for resolving optional dependencies.
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the specified name
  `BeansException` - if the bean could not be obtained

### getBean

public <T> T getBean(String name, @Nullable Class<T> requiredType) throws BeansException
Description copied from interface: `BeanFactory`
Return an instance, which may be shared or independent, of the specified bean.

Behaves the same as `BeanFactory.getBean(String)`, but provides a measure of type safety by throwing a BeanNotOfRequiredTypeException if the bean is not of the required type. This means that ClassCastException can't be thrown on casting the result correctly, as can happen with `BeanFactory.getBean(String)`.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `getBean` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to retrieve
  `requiredType` - type the bean must match; can be an interface or superclass
Returns:
  an instance of the bean. Note that the return value will never be `null`. In case of a stub for `null` from a factory method having been resolved for the requested bean, a `BeanNotOfRequiredTypeException` against the NullBean stub will be raised. Consider using `BeanFactory.getBeanProvider(Class)` for resolving optional dependencies.
Throws:
  `NoSuchBeanDefinitionException` - if there is no such bean definition
  `BeanNotOfRequiredTypeException` - if the bean is not of the required type
  `BeansException` - if the bean could not be created

### getBean

public Object getBean(String name, Object... args) throws BeansException
Description copied from interface: `BeanFactory`
Return an instance, which may be shared or independent, of the specified bean.

Allows for specifying explicit constructor arguments / factory method arguments, overriding the specified default arguments (if any) in the bean definition. Note that the provided arguments need to match a specific candidate constructor / factory method in the order of declared parameters.

Specified by:
  `getBean` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to retrieve
  `args` - arguments to use when creating a bean instance using explicit arguments (only applied when creating a new instance as opposed to retrieving an existing one)
Returns:
  an instance of the bean
Throws:
  `NoSuchBeanDefinitionException` - if there is no such bean definition
  `BeanDefinitionStoreException` - if arguments have been given but the affected bean isn't a prototype
  `BeansException` - if the bean could not be created

### getBean

public <T> T getBean(Class<T> requiredType) throws BeansException
Description copied from interface: `BeanFactory`
Return the bean instance that uniquely matches the given object type, if any.

This method goes into `ListableBeanFactory` by-type lookup territory but may also be translated into a conventional by-name lookup based on the name of the given type. For more extensive retrieval operations across sets of beans, use `ListableBeanFactory` and/or `BeanFactoryUtils`.

Specified by:
  `getBean` in interface `BeanFactory`
Parameters:
  `requiredType` - type the bean must match; can be an interface or superclass
Returns:
  an instance of the single bean matching the required type
Throws:
  `NoSuchBeanDefinitionException` - if no bean of the given type was found
  `NoUniqueBeanDefinitionException` - if more than one bean of the given type was found
  `BeansException` - if the bean could not be created
See Also:
  - `ListableBeanFactory`

### getBean

public <T> T getBean(Class<T> requiredType, Object... args) throws BeansException
Description copied from interface: `BeanFactory`
Return an instance, which may be shared or independent, of the specified bean.

Allows for specifying explicit constructor arguments / factory method arguments, overriding the specified default arguments (if any) in the bean definition. Note that the provided arguments need to match a specific candidate constructor / factory method in the order of declared parameters.

This method goes into `ListableBeanFactory` by-type lookup territory but may also be translated into a conventional by-name lookup based on the name of the given type. For more extensive retrieval operations across sets of beans, use `ListableBeanFactory` and/or `BeanFactoryUtils`.

Specified by:
  `getBean` in interface `BeanFactory`
Parameters:
  `requiredType` - type the bean must match; can be an interface or superclass
  `args` - arguments to use when creating a bean instance using explicit arguments (only applied when creating a new instance as opposed to retrieving an existing one)
Returns:
  an instance of the bean
Throws:
  `NoSuchBeanDefinitionException` - if there is no such bean definition
  `BeanDefinitionStoreException` - if arguments have been given but the affected bean isn't a prototype
  `BeansException` - if the bean could not be created

### getBeanProvider

public <T> ObjectProvider<T> getBeanProvider(Class<T> requiredType) throws BeansException
Description copied from interface: `BeanFactory`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.

For matching a generic type, consider `BeanFactory.getBeanProvider(ResolvableType)`.

Specified by:
  `getBeanProvider` in interface `BeanFactory`
Parameters:
  `requiredType` - type the bean must match; can be an interface or superclass
Returns:
  a corresponding provider handle
Throws:
  `BeansException`
See Also:
  - `BeanFactory.getBeanProvider(ResolvableType)`

### getBeanProvider

public <T> ObjectProvider<T> getBeanProvider(org.springframework.core.ResolvableType requiredType)
Description copied from interface: `BeanFactory`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options. This variant allows for specifying a generic type to match, similar to reflective injection points with generic type declarations in method/constructor parameters.

Note that collections of beans are not supported here, in contrast to reflective injection points. For programmatically retrieving a list of beans matching a specific type, specify the actual bean type as an argument here and subsequently use `ObjectProvider.orderedStream()` or its lazy streaming/iteration options.

Also, generics matching is strict here, as per the Java assignment rules. For lenient fallback matching with unchecked semantics (similar to the 'unchecked' Java compiler warning), consider calling `BeanFactory.getBeanProvider(Class)` with the raw type as a second step if no full generic match is `available` with this variant.

Specified by:
  `getBeanProvider` in interface `BeanFactory`
Parameters:
  `requiredType` - type the bean must match; can be a generic type declaration
Returns:
  a corresponding provider handle
See Also:
  - `ObjectProvider.iterator()`
  - `ObjectProvider.stream()`
  - `ObjectProvider.orderedStream()`

### containsBean

public boolean containsBean(String name)
Description copied from interface: `BeanFactory`
Does this bean factory contain a bean definition or externally registered singleton instance with the given name?

If the given name is an alias, it will be translated back to the corresponding canonical bean name.

If this factory is hierarchical, will ask any parent factory if the bean cannot be found in this factory instance.

If a bean definition or singleton instance matching the given name is found, this method will return `true` whether the named bean definition is concrete or abstract, lazy or eager, in scope or not. Therefore, note that a `true` return value from this method does not necessarily indicate that `BeanFactory.getBean(java.lang.String)` will be able to obtain an instance for the same name.

Specified by:
  `containsBean` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to query
Returns:
  whether a bean with the given name is present

### isSingleton

public boolean isSingleton(String name) throws NoSuchBeanDefinitionException
Description copied from interface: `BeanFactory`
Is this bean a shared singleton? That is, will `BeanFactory.getBean(java.lang.String)` always return the same instance?

Note: This method returning `false` does not clearly indicate independent instances. It indicates non-singleton instances, which may correspond to a scoped bean as well. Use the `BeanFactory.isPrototype(java.lang.String)` operation to explicitly check for independent instances.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `isSingleton` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to query
Returns:
  whether this bean corresponds to a singleton instance
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `BeanFactory.getBean(java.lang.String)`
  - `BeanFactory.isPrototype(java.lang.String)`

### isPrototype

public boolean isPrototype(String name) throws NoSuchBeanDefinitionException
Description copied from interface: `BeanFactory`
Is this bean a prototype? That is, will `BeanFactory.getBean(java.lang.String)` always return independent instances?

Note: This method returning `false` does not clearly indicate a singleton object. It indicates non-independent instances, which may correspond to a scoped bean as well. Use the `BeanFactory.isSingleton(java.lang.String)` operation to explicitly check for a shared singleton instance.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `isPrototype` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to query
Returns:
  whether this bean will always deliver independent instances
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `BeanFactory.getBean(java.lang.String)`
  - `BeanFactory.isSingleton(java.lang.String)`

### isTypeMatch

public boolean isTypeMatch(String name, org.springframework.core.ResolvableType typeToMatch) throws NoSuchBeanDefinitionException
Description copied from interface: `BeanFactory`
Check whether the bean with the given name matches the specified type. More specifically, check whether a `BeanFactory.getBean(java.lang.String)` call for the given name would return an object that is assignable to the specified target type.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `isTypeMatch` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to query
  `typeToMatch` - the type to match against (as a `ResolvableType`)
Returns:
  `true` if the bean type matches, `false` if it doesn't match or cannot be determined yet
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `BeanFactory.getBean(java.lang.String)`
  - `BeanFactory.getType(java.lang.String)`

### isTypeMatch

public boolean isTypeMatch(String name, @Nullable Class<?> typeToMatch) throws NoSuchBeanDefinitionException
Description copied from interface: `BeanFactory`
Check whether the bean with the given name matches the specified type. More specifically, check whether a `BeanFactory.getBean(java.lang.String)` call for the given name would return an object that is assignable to the specified target type.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `isTypeMatch` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to query
  `typeToMatch` - the type to match against (as a `Class`)
Returns:
  `true` if the bean type matches, `false` if it doesn't match or cannot be determined yet
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `BeanFactory.getBean(java.lang.String)`
  - `BeanFactory.getType(java.lang.String)`

### getType

@Nullable public Class<?> getType(String name) throws NoSuchBeanDefinitionException
Description copied from interface: `BeanFactory`
Determine the type of the bean with the given name. More specifically, determine the type of object that `BeanFactory.getBean(java.lang.String)` would return for the given name.

For a `FactoryBean`, return the type of object that the FactoryBean creates, as exposed by `FactoryBean.getObjectType()`. This may lead to the initialization of a previously uninitialized `FactoryBean` (see `BeanFactory.getType(String, boolean)`).

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `getType` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to query
Returns:
  the type of the bean, or `null` if not determinable
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `BeanFactory.getBean(java.lang.String)`
  - `BeanFactory.isTypeMatch(java.lang.String, org.springframework.core.ResolvableType)`

### getType

@Nullable public Class<?> getType(String name, boolean allowFactoryBeanInit) throws NoSuchBeanDefinitionException
Description copied from interface: `BeanFactory`
Determine the type of the bean with the given name. More specifically, determine the type of object that `BeanFactory.getBean(java.lang.String)` would return for the given name.

For a `FactoryBean`, return the type of object that the FactoryBean creates, as exposed by `FactoryBean.getObjectType()`. Depending on the `allowFactoryBeanInit` flag, this may lead to the initialization of a previously uninitialized `FactoryBean` if no early type information is available.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `getType` in interface `BeanFactory`
Parameters:
  `name` - the name of the bean to query
  `allowFactoryBeanInit` - whether a `FactoryBean` may get initialized just for the purpose of determining its object type
Returns:
  the type of the bean, or `null` if not determinable
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `BeanFactory.getBean(java.lang.String)`
  - `BeanFactory.isTypeMatch(java.lang.String, org.springframework.core.ResolvableType)`

### getAliases

public String[] getAliases(String name)
Description copied from interface: `BeanFactory`
Return the aliases for the given bean name, if any.

All of those aliases point to the same bean when used in a `BeanFactory.getBean(java.lang.String)` call.

If the given name is an alias, the corresponding original bean name and other aliases (if any) will be returned, with the original bean name being the first element in the array.

Will ask the parent factory if the bean cannot be found in this factory instance.

Specified by:
  `getAliases` in interface `BeanFactory`
Parameters:
  `name` - the bean name to check for aliases
Returns:
  the aliases, or an empty array if none
See Also:
  - `BeanFactory.getBean(java.lang.String)`

### containsBeanDefinition

public boolean containsBeanDefinition(String name)
Description copied from interface: `ListableBeanFactory`
Check if this bean factory contains a bean definition with the given name.

Does not consider any hierarchy this factory may participate in, and ignores any singleton beans that have been registered by other means than bean definitions.

Specified by:
  `containsBeanDefinition` in interface `ListableBeanFactory`
Parameters:
  `name` - the name of the bean to look for
Returns:
  if this bean factory contains a bean definition with the given name
See Also:
  - `BeanFactory.containsBean(java.lang.String)`

### getBeanDefinitionCount

public int getBeanDefinitionCount()
Description copied from interface: `ListableBeanFactory`
Return the number of beans defined in the factory.

Does not consider any hierarchy this factory may participate in, and ignores any singleton beans that have been registered by other means than bean definitions.

Specified by:
  `getBeanDefinitionCount` in interface `ListableBeanFactory`
Returns:
  the number of beans defined in the factory

### getBeanDefinitionNames

public String[] getBeanDefinitionNames()
Description copied from interface: `ListableBeanFactory`
Return the names of all beans defined in this factory.

Does not consider any hierarchy this factory may participate in, and ignores any singleton beans that have been registered by other means than bean definitions.

Specified by:
  `getBeanDefinitionNames` in interface `ListableBeanFactory`
Returns:
  the names of all beans defined in this factory, or an empty array if none defined

### getBeanProvider

public <T> ObjectProvider<T> getBeanProvider(Class<T> requiredType, boolean allowEagerInit)
Description copied from interface: `ListableBeanFactory`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.

Specified by:
  `getBeanProvider` in interface `ListableBeanFactory`
Parameters:
  `requiredType` - type the bean must match; can be an interface or superclass
  `allowEagerInit` - whether stream access may introspect lazy-init singletons and objects created by FactoryBeans - or by factory methods with a "factory-bean" reference - for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references. Only actually necessary initialization for type checking purposes will be performed; constructor and method invocations will still be avoided as far as possible.
Returns:
  a corresponding provider handle
See Also:
  - `ListableBeanFactory.getBeanProvider(ResolvableType, boolean)`
  - `BeanFactory.getBeanProvider(Class)`
  - `ListableBeanFactory.getBeansOfType(Class, boolean, boolean)`
  - `ListableBeanFactory.getBeanNamesForType(Class, boolean, boolean)`

### getBeanProvider

public <T> ObjectProvider<T> getBeanProvider(org.springframework.core.ResolvableType requiredType, boolean allowEagerInit)
Description copied from interface: `ListableBeanFactory`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.

Specified by:
  `getBeanProvider` in interface `ListableBeanFactory`
Parameters:
  `requiredType` - type the bean must match; can be a generic type declaration. Note that collection types are not supported here, in contrast to reflective injection points. For programmatically retrieving a list of beans matching a specific type, specify the actual bean type as an argument here and subsequently use `ObjectProvider.orderedStream()` or its lazy streaming/iteration options.
  `allowEagerInit` - whether stream access may introspect lazy-init singletons and objects created by FactoryBeans - or by factory methods with a "factory-bean" reference - for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references. Only actually necessary initialization for type checking purposes will be performed; constructor and method invocations will still be avoided as far as possible.
Returns:
  a corresponding provider handle
See Also:
  - `BeanFactory.getBeanProvider(ResolvableType)`
  - `ObjectProvider.iterator()`
  - `ObjectProvider.stream()`
  - `ObjectProvider.orderedStream()`
  - `ListableBeanFactory.getBeanNamesForType(ResolvableType, boolean, boolean)`

### getBeanNamesForType

public String[] getBeanNamesForType(@Nullable org.springframework.core.ResolvableType type)
Description copied from interface: `ListableBeanFactory`
Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beanNamesForTypeIncludingAncestors` to include beans in ancestor factories too.

This version of `getBeanNamesForType` matches all kinds of beans, be it singletons, prototypes, or FactoryBeans. In most implementations, the result will be the same as for `getBeanNamesForType(type, true, true)`.

Bean names returned by this method should always return bean names in the order of definition in the backend configuration, as far as possible.

Specified by:
  `getBeanNamesForType` in interface `ListableBeanFactory`
Parameters:
  `type` - the generically typed class or interface to match
Returns:
  the names of beans (or objects created by FactoryBeans) matching the given object type (including subclasses), or an empty array if none
See Also:
  - `BeanFactory.isTypeMatch(String, ResolvableType)`
  - `FactoryBean.getObjectType()`
  - `BeanFactoryUtils.beanNamesForTypeIncludingAncestors(ListableBeanFactory, ResolvableType)`

### getBeanNamesForType

public String[] getBeanNamesForType(@Nullable org.springframework.core.ResolvableType type, boolean includeNonSingletons, boolean allowEagerInit)
Description copied from interface: `ListableBeanFactory`
Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beanNamesForTypeIncludingAncestors` to include beans in ancestor factories too.

Bean names returned by this method should always return bean names in the order of definition in the backend configuration, as far as possible.

Specified by:
  `getBeanNamesForType` in interface `ListableBeanFactory`
Parameters:
  `type` - the generically typed class or interface to match
  `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
  `allowEagerInit` - whether to introspect lazy-init singletons and objects created by FactoryBeans - or by factory methods with a "factory-bean" reference - for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references. Only actually necessary initialization for type checking purposes will be performed; constructor and method invocations will still be avoided as far as possible.
Returns:
  the names of beans (or objects created by FactoryBeans) matching the given object type (including subclasses), or an empty array if none
See Also:
  - `FactoryBean.getObjectType()`
  - `BeanFactoryUtils.beanNamesForTypeIncludingAncestors(ListableBeanFactory, ResolvableType, boolean, boolean)`

### getBeanNamesForType

public String[] getBeanNamesForType(@Nullable Class<?> type)
Description copied from interface: `ListableBeanFactory`
Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beanNamesForTypeIncludingAncestors` to include beans in ancestor factories too.

This version of `getBeanNamesForType` matches all kinds of beans, be it singletons, prototypes, or FactoryBeans. In most implementations, the result will be the same as for `getBeanNamesForType(type, true, true)`.

Bean names returned by this method should always return bean names in the order of definition in the backend configuration, as far as possible.

Specified by:
  `getBeanNamesForType` in interface `ListableBeanFactory`
Parameters:
  `type` - the class or interface to match, or `null` for all bean names
Returns:
  the names of beans (or objects created by FactoryBeans) matching the given object type (including subclasses), or an empty array if none
See Also:
  - `FactoryBean.getObjectType()`
  - `BeanFactoryUtils.beanNamesForTypeIncludingAncestors(ListableBeanFactory, Class)`

### getBeanNamesForType

public String[] getBeanNamesForType(@Nullable Class<?> type, boolean includeNonSingletons, boolean allowEagerInit)
Description copied from interface: `ListableBeanFactory`
Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beanNamesForTypeIncludingAncestors` to include beans in ancestor factories too.

Bean names returned by this method should always return bean names in the order of definition in the backend configuration, as far as possible.

Specified by:
  `getBeanNamesForType` in interface `ListableBeanFactory`
Parameters:
  `type` - the class or interface to match, or `null` for all bean names
  `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
  `allowEagerInit` - whether to introspect lazy-init singletons and objects created by FactoryBeans - or by factory methods with a "factory-bean" reference - for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references. Only actually necessary initialization for type checking purposes will be performed; constructor and method invocations will still be avoided as far as possible.
Returns:
  the names of beans (or objects created by FactoryBeans) matching the given object type (including subclasses), or an empty array if none
See Also:
  - `FactoryBean.getObjectType()`
  - `BeanFactoryUtils.beanNamesForTypeIncludingAncestors(ListableBeanFactory, Class, boolean, boolean)`

### getBeansOfType

public <T> Map<String,T> getBeansOfType(@Nullable Class<T> type) throws BeansException
Description copied from interface: `ListableBeanFactory`
Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well. Also, it suppresses exceptions for beans that are currently in creation in a circular reference scenario: typically, references back to the caller of this method.

Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beansOfTypeIncludingAncestors` to include beans in ancestor factories too.

This version of getBeansOfType matches all kinds of beans, be it singletons, prototypes, or FactoryBeans. In most implementations, the result will be the same as for `getBeansOfType(type, true, true)`.

The Map returned by this method should always return bean names and corresponding bean instances in the order of definition in the backend configuration, as far as possible.

Consider `ListableBeanFactory.getBeanNamesForType(Class)` with selective `BeanFactory.getBean(java.lang.String)` calls for specific bean names in preference to this Map-based retrieval method. Aside from lazy instantiation benefits, this also avoids any exception suppression.

Specified by:
  `getBeansOfType` in interface `ListableBeanFactory`
Parameters:
  `type` - the class or interface to match, or `null` for all concrete beans
Returns:
  a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values
Throws:
  `BeansException` - if a bean could not be created
See Also:
  - `FactoryBean.getObjectType()`
  - `BeanFactoryUtils.beansOfTypeIncludingAncestors(ListableBeanFactory, Class)`

### getBeansOfType

public <T> Map<String,T> getBeansOfType(@Nullable Class<T> type, boolean includeNonSingletons, boolean allowEagerInit) throws BeansException
Description copied from interface: `ListableBeanFactory`
Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well. Also, it suppresses exceptions for beans that are currently in creation in a circular reference scenario: typically, references back to the caller of this method.

Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beansOfTypeIncludingAncestors` to include beans in ancestor factories too.

The Map returned by this method should always return bean names and corresponding bean instances in the order of definition in the backend configuration, as far as possible.

Consider `ListableBeanFactory.getBeanNamesForType(Class)` with selective `BeanFactory.getBean(java.lang.String)` calls for specific bean names in preference to this Map-based retrieval method. Aside from lazy instantiation benefits, this also avoids any exception suppression.

Specified by:
  `getBeansOfType` in interface `ListableBeanFactory`
Parameters:
  `type` - the class or interface to match, or `null` for all concrete beans
  `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
  `allowEagerInit` - whether to introspect lazy-init singletons and objects created by FactoryBeans - or by factory methods with a "factory-bean" reference - for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references. Only actually necessary initialization for type checking purposes will be performed; constructor and method invocations will still be avoided as far as possible.
Returns:
  a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values
Throws:
  `BeansException` - if a bean could not be created
See Also:
  - `FactoryBean.getObjectType()`
  - `BeanFactoryUtils.beansOfTypeIncludingAncestors(ListableBeanFactory, Class, boolean, boolean)`

### getBeanNamesForAnnotation

public String[] getBeanNamesForAnnotation(Class<? extends Annotation> annotationType)
Description copied from interface: `ListableBeanFactory`
Find all names of beans which are annotated with the supplied `Annotation` type, without creating corresponding bean instances yet.

Note that this method considers objects created by FactoryBeans, which means that FactoryBeans will get initialized in order to determine their object type.

Specified by:
  `getBeanNamesForAnnotation` in interface `ListableBeanFactory`
Parameters:
  `annotationType` - the type of annotation to look for (at class, interface or factory method level of the specified bean)
Returns:
  the names of all matching beans
See Also:
  - `ListableBeanFactory.getBeansWithAnnotation(Class)`
  - `ListableBeanFactory.findAnnotationOnBean(String, Class)`

### getBeansWithAnnotation

public Map<String,Object> getBeansWithAnnotation(Class<? extends Annotation> annotationType) throws BeansException
Description copied from interface: `ListableBeanFactory`
Find all beans which are annotated with the supplied `Annotation` type, returning a Map of bean names with corresponding bean instances.

Note that this method considers objects created by FactoryBeans, which means that FactoryBeans will get initialized in order to determine their object type.

Specified by:
  `getBeansWithAnnotation` in interface `ListableBeanFactory`
Parameters:
  `annotationType` - the type of annotation to look for (at class, interface or factory method level of the specified bean)
Returns:
  a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values
Throws:
  `BeansException` - if a bean could not be created
See Also:
  - `ListableBeanFactory.findAnnotationOnBean(String, Class)`
  - `ListableBeanFactory.findAnnotationOnBean(String, Class, boolean)`
  - `ListableBeanFactory.findAllAnnotationsOnBean(String, Class, boolean)`

### findAnnotationOnBean

@Nullable public <A extends Annotation> A findAnnotationOnBean(String beanName, Class<A> annotationType) throws NoSuchBeanDefinitionException
Description copied from interface: `ListableBeanFactory`
Find an `Annotation` of `annotationType` on the specified bean, traversing its interfaces and superclasses if no annotation can be found on the given class itself, as well as checking the bean's factory method (if any).

Specified by:
  `findAnnotationOnBean` in interface `ListableBeanFactory`
Parameters:
  `beanName` - the name of the bean to look for annotations on
  `annotationType` - the type of annotation to look for (at class, interface or factory method level of the specified bean)
Returns:
  the annotation of the given type if found, or `null` otherwise
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `ListableBeanFactory.findAnnotationOnBean(String, Class, boolean)`
  - `ListableBeanFactory.findAllAnnotationsOnBean(String, Class, boolean)`
  - `ListableBeanFactory.getBeanNamesForAnnotation(Class)`
  - `ListableBeanFactory.getBeansWithAnnotation(Class)`
  - `BeanFactory.getType(String)`

### findAnnotationOnBean

@Nullable public <A extends Annotation> A findAnnotationOnBean(String beanName, Class<A> annotationType, boolean allowFactoryBeanInit) throws NoSuchBeanDefinitionException
Description copied from interface: `ListableBeanFactory`
Find an `Annotation` of `annotationType` on the specified bean, traversing its interfaces and superclasses if no annotation can be found on the given class itself, as well as checking the bean's factory method (if any).

Specified by:
  `findAnnotationOnBean` in interface `ListableBeanFactory`
Parameters:
  `beanName` - the name of the bean to look for annotations on
  `annotationType` - the type of annotation to look for (at class, interface or factory method level of the specified bean)
  `allowFactoryBeanInit` - whether a `FactoryBean` may get initialized just for the purpose of determining its object type
Returns:
  the annotation of the given type if found, or `null` otherwise
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `ListableBeanFactory.findAnnotationOnBean(String, Class)`
  - `ListableBeanFactory.findAllAnnotationsOnBean(String, Class, boolean)`
  - `ListableBeanFactory.getBeanNamesForAnnotation(Class)`
  - `ListableBeanFactory.getBeansWithAnnotation(Class)`
  - `BeanFactory.getType(String, boolean)`

### findAllAnnotationsOnBean

public <A extends Annotation> Set<A> findAllAnnotationsOnBean(String beanName, Class<A> annotationType, boolean allowFactoryBeanInit) throws NoSuchBeanDefinitionException
Description copied from interface: `ListableBeanFactory`
Find all `Annotation` instances of `annotationType` on the specified bean, traversing its interfaces and superclasses if no annotation can be found on the given class itself, as well as checking the bean's factory method (if any).

Specified by:
  `findAllAnnotationsOnBean` in interface `ListableBeanFactory`
Parameters:
  `beanName` - the name of the bean to look for annotations on
  `annotationType` - the type of annotation to look for (at class, interface or factory method level of the specified bean)
  `allowFactoryBeanInit` - whether a `FactoryBean` may get initialized just for the purpose of determining its object type
Returns:
  the set of annotations of the given type found (potentially empty)
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `ListableBeanFactory.getBeanNamesForAnnotation(Class)`
  - `ListableBeanFactory.findAnnotationOnBean(String, Class, boolean)`
  - `BeanFactory.getType(String, boolean)`